---
title: CanvasRenderingContext2D.closePath()
slug: Web/API/CanvasRenderingContext2D/closePath
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.closePath()</code></strong> method of the Canvas 2D API attempts to add a straight line from the current point to the start of the current sub-path. If the shape has already been closed or has only one point, this function does nothing.</p>

<p>This method doesn't draw anything to the canvas directly. You can render the path using the {{domxref("CanvasRenderingContext2D.stroke()", "stroke()")}} or {{domxref("CanvasRenderingContext2D.fill()", "fill()")}} methods.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <em>ctx</em>.closePath();
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Closing_a_triangle">Closing a triangle</h3>

<p>This example creates the first two (diagonal) sides of a triangle using the <code>lineTo()</code> method. After that, the triangle's base is created with the <code>closePath()</code> method, which automatically connects the shape's first and last points.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The triangle's corners are at (20, 140), (120, 10), and (220, 140).</p>

<pre class="brush: js; highlight:[8] notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.beginPath();
ctx.moveTo(20, 140);   // Move pen to bottom-left corner
ctx.lineTo(120, 10);   // Line to top corner
ctx.lineTo(220, 140);  // Line to bottom-right corner
ctx.closePath();       // Line to bottom-left corner
ctx.stroke();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Closing_a_triangle', 700, 180) }}</p>

<h3 id="Closing_just_one_sub-path">Closing just one sub-path</h3>

<p>This example draws a smiley face consisting of three disconnected sub-paths.</p>

<div class="notecard note">
<p>Note: Although <code>closePath()</code> is called after all the arcs have been created, only the last arc (sub-path) gets closed.</p>
</div>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>The first two arcs create the face's eyes. The last arc creates the mouth.</p>

<pre class="brush: js; highlight:[10] notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.beginPath();
ctx.arc(240, 20, 40, 0, Math.PI);
ctx.moveTo(100, 20);
ctx.arc(60, 20, 40, 0, Math.PI);
ctx.moveTo(215, 80);
ctx.arc(150, 80, 65, 0, Math.PI);
ctx.closePath();
ctx.lineWidth = 6;
ctx.stroke();
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Closing_just_one_sub-path', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-closepath", "CanvasRenderingContext2D.closePath")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.closePath")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.beginPath()")}}</li>
</ul>
